uniform sampler2D base_tex_unit; // zakladna textura

uniform vec4 vertTapOffs2;
uniform vec4 vertTapOffs3;

// prenasane udaje
in vec2 uv;
in vec2 Tap[4],TapNeg[3];

void main (void)
{
 // pomocne premenne
 vec4 s[7];
 vec4 ColorWeightSum;
 vec2 Tap2[3],TapNeg2[3];

 // vahy vzoriek
 const vec4 Weights0=vec4(0.080,0.075,0.070,0.100);
 const vec4 Weights1=vec4(0.065,0.060,0.055,0.050);

 // vzorky Gausovho filtra
 s[0]=texture(base_tex_unit,Tap[0]);
 s[1]=texture(base_tex_unit,Tap[1]);
 s[2]=texture(base_tex_unit,Tap[2]);
 s[3]=texture(base_tex_unit,Tap[3]);
 s[4]=texture(base_tex_unit,TapNeg[0]);
 s[5]=texture(base_tex_unit,TapNeg[1]);
 s[6]=texture(base_tex_unit,TapNeg[2]);

 // modulacia vzoriek pomocou ich vah
 s[0].rgb=s[0].rgb*s[0].a;
 s[1].rgb=s[1].rgb*s[1].a;
 s[2].rgb=s[2].rgb*s[2].a;
 s[3].rgb=s[3].rgb*s[3].a;
 s[4].rgb=s[4].rgb*s[4].a;
 s[5].rgb=s[5].rgb*s[5].a;
 s[6].rgb=s[6].rgb*s[6].a;

 // scitanie vzoriek ohodnotenych ich vahami, sucet vah do alfa
 ColorWeightSum=s[0]*Weights0.w+
                (s[1]+s[4])*Weights0.x+
                (s[2]+s[5])*Weights0.y+
                (s[3]+s[6])*Weights0.z;

 // vzorky Gausovho filtra
 Tap2[0]=Tap[0]+vertTapOffs2.xy;
 Tap2[1]=Tap[0]+vertTapOffs2.zw;
 Tap2[2]=Tap[0]+vertTapOffs3.xy;
 TapNeg2[0]=Tap[0]-vertTapOffs2.xy;
 TapNeg2[1]=Tap[0]-vertTapOffs2.zw;
 TapNeg2[2]=Tap[0]-vertTapOffs3.xy;
 s[0]=texture2D(base_tex_unit,Tap2[0]);
 s[1]=texture2D(base_tex_unit,Tap2[1]);
 s[2]=texture2D(base_tex_unit,Tap2[2]);
 s[3]=texture2D(base_tex_unit,TapNeg2[0]);
 s[4]=texture2D(base_tex_unit,TapNeg2[1]);
 s[5]=texture2D(base_tex_unit,TapNeg2[2]);

 // modulacia vzoriek pomocou ich vah
 s[0].rgb=s[0].rgb*s[0].a;
 s[1].rgb=s[1].rgb*s[1].a;
 s[2].rgb=s[2].rgb*s[2].a;
 s[3].rgb=s[3].rgb*s[3].a;
 s[4].rgb=s[4].rgb*s[4].a;
 s[5].rgb=s[5].rgb*s[5].a;

 // pricitanie vzoriek ohodnotenych ich vahami, sucet vah do alfa
 ColorWeightSum+=(s[1]+s[3])*Weights1.x+
                 (s[1]+s[4])*Weights1.y+
                 (s[2]+s[5])*Weights1.z;

 // podiel 13 vzoriek (6+1+6) a ich vah
 ColorWeightSum.rgb/=ColorWeightSum.a;

 // ulozenie vzoriek do textury
 gl_FragData[0]=ColorWeightSum;
}
